//---------------------------------------------------------------------------

#include <vcl.h>
#include <Sockets.hpp>
#pragma hdrstop
#include "mainUnit.h"
#include "connect_thread.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------

//   Important: Methods and properties of objects in VCL can only be
//   used in a method called using Synchronize, for example:
//
//      Synchronize(&UpdateCaption);
//
//   where UpdateCaption could look like:
//
//      void __fastcall TConnectThread::UpdateCaption()
//      {
//        Form1->Caption = "Updated in a thread";
//      }
//---------------------------------------------------------------------------

__fastcall TConnectThread::TConnectThread(AnsiString asAddress,
	AnsiString asPort, bool CreateSuspended)
	: TThread(CreateSuspended)
{
    FreeOnTerminate = true;
	scanAddress = asAddress;
	scanPort = asPort;
}

//---------------------------------------------------------------------------
void __fastcall TConnectThread::Execute()
{
	TTcpClient *tcpClient = new TTcpClient(NULL);
	tcpClient->BlockMode = bmBlocking;
	tcpClient->RemoteHost = scanAddress;
	tcpClient->RemotePort = scanPort;
	tcpClient->Connect();
	if(tcpClient->Connected)
	{
		Synchronize(&AddServer);
	}
	tcpClient->Close();
	delete tcpClient;
	tcpClient = NULL;
	Synchronize(&DecThreadsNo);
}
//---------------------------------------------------------------------------

void __fastcall TConnectThread::AddServer()
{
	TListItem *item = frmMain->lvFound->Items->Add();
	item->Caption = scanAddress;
}

void __fastcall TConnectThread::DecThreadsNo()
{
	frmMain->iActiveThreads--;
	frmMain->StatusBar1->Panels->Items[1]->Text = "Threads: " + IntToStr(frmMain->iActiveThreads);
}
